Index: soft/giet_vm/giet_libs/mwmr_channel.c
===================================================================
--- soft/giet_vm/giet_libs/mwmr_channel.c	(revision 479)
+++ soft/giet_vm/giet_libs/mwmr_channel.c	(revision 693)
@@ -23,5 +23,5 @@
 unsigned int    lpid;
 giet_proc_xyp( &x, &y, &lpid );
-giet_shr_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] initialises fifo %x / "
+giet_tty_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] initialises fifo %x / "
                 " buffer = %x / width = %d / nitems = %d\n",
                 x, y, lpid, (unsigned int)mwmr, (unsigned int)buffer, width, nitems );
@@ -50,5 +50,5 @@
 unsigned int    lpid;
 giet_proc_xyp( &x, &y, &lpid );
-giet_shr_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] enters nb_mwmr_write()"
+giet_tty_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] enters nb_mwmr_write()"
                 " : mwmr = %x / buffer = %x / items =  %d\n",
                 x, y, lpid, (unsigned int)mwmr, (unsigned int)buffer, items );
@@ -88,5 +88,5 @@
 
 #if GIET_DEBUG_USER_MWMR
-giet_shr_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] writes %d words in fifo %x : sts = %d\n",
+giet_tty_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] writes %d words in fifo %x : sts = %d\n",
                 x, y, lpid, nwords, (unsigned int)mwmr, mwmr->sts );
 #endif
@@ -113,5 +113,5 @@
 
 #if GIET_DEBUG_USER_MWMR
-giet_shr_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] writes %d words in fifo %x : sts = %d\n",
+giet_tty_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] writes %d words in fifo %x : sts = %d\n",
                 x, y, lpid, nwords, (unsigned int)mwmr, mwmr->sts );
 #endif
@@ -135,5 +135,5 @@
 unsigned int    lpid;
 giet_proc_xyp( &x, &y, &lpid );
-giet_shr_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] enters nb_mwmr_read()"
+giet_tty_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] enters nb_mwmr_read()"
                 " : mwmr = %x / buffer = %x / items =  %d\n",
                 x, y, lpid, (unsigned int)mwmr, (unsigned int)buffer, items );
@@ -171,5 +171,5 @@
 
 #if GIET_DEBUG_USER_MWMR
-giet_shr_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] read %d words in fifo %x : sts = %d\n",
+giet_tty_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] read %d words in fifo %x : sts = %d\n",
                 x, y, lpid, nwords, (unsigned int)mwmr, mwmr->sts );
 #endif
@@ -182,5 +182,5 @@
 
 #if GIET_DEBUG_USER_MWMR
-giet_shr_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] read nothing in fifo %x : sts = %d\n",
+giet_tty_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] read nothing in fifo %x : sts = %d\n",
                 x, y, lpid, (unsigned int)mwmr, mwmr->sts );
 #endif
@@ -202,5 +202,5 @@
 
 #if GIET_DEBUG_USER_MWMR
-giet_shr_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] read %d words in fifo %x : sts = %d\n",
+giet_tty_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] read %d words in fifo %x : sts = %d\n",
                 x, y, lpid, nwords, (unsigned int)mwmr, mwmr->sts );
 #endif
@@ -224,5 +224,5 @@
 unsigned int    lpid;
 giet_proc_xyp( &x, &y, &lpid );
-giet_shr_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] enters mwmr_write()"
+giet_tty_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] enters mwmr_write()"
                 " : mwmr = %x / buffer = %x / items =  %d\n",
                 x, y, lpid, (unsigned int)mwmr, (unsigned int)buffer, items );
@@ -264,5 +264,5 @@
 
 #if GIET_DEBUG_USER_MWMR
-giet_shr_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] writes %d words in fifo %x : sts = %d\n",
+giet_tty_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] writes %d words in fifo %x : sts = %d\n",
                 x, y, lpid, nwords, (unsigned int)mwmr, mwmr->sts );
 #endif
@@ -290,5 +290,5 @@
 
 #if GIET_DEBUG_USER_MWMR
-giet_shr_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] writes %d words in fifo %x : sts = %d\n",
+giet_tty_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] writes %d words in fifo %x : sts = %d\n",
                 x, y, lpid, nwords, (unsigned int)mwmr, mwmr->sts );
 #endif
@@ -314,5 +314,5 @@
 unsigned int    lpid;
 giet_proc_xyp( &x, &y, &lpid );
-giet_shr_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] enters mwmr_read()"
+giet_tty_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] enters mwmr_read()"
                 " : mwmr = %x / buffer = %x / items =  %d\n",
                 x, y, lpid, (unsigned int)mwmr, (unsigned int)buffer, items );
@@ -352,5 +352,5 @@
 
 #if GIET_DEBUG_USER_MWMR
-giet_shr_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] read %d words in fifo %x : sts = %d\n",
+giet_tty_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] read %d words in fifo %x : sts = %d\n",
                 x, y, lpid, nwords, (unsigned int)mwmr, mwmr->sts );
 #endif
@@ -378,5 +378,5 @@
 
 #if GIET_DEBUG_USER_MWMR
-giet_shr_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] read %d words in fifo %x : sts = %d\n",
+giet_tty_printf("\n[MWMR DEBUG] Proc[%d,%d,%d] read %d words in fifo %x : sts = %d\n",
                 x, y, lpid, nwords, (unsigned int)mwmr, mwmr->sts );
 #endif