Index: branches/fault_tolerance/platform/tsar_generic_iob/tsar_iob_cluster/caba/source/include/tsar_iob_cluster.h
===================================================================
--- branches/fault_tolerance/platform/tsar_generic_iob/tsar_iob_cluster/caba/source/include/tsar_iob_cluster.h	(revision 695)
+++ branches/fault_tolerance/platform/tsar_generic_iob/tsar_iob_cluster/caba/source/include/tsar_iob_cluster.h	(revision 696)
@@ -23,4 +23,5 @@
 #include "vci_simple_rom.h"
 #include "vci_xicu.h"
+#include "vci_local_crossbar.h"
 #include "dspin_local_crossbar.h"
 #include "vci_dspin_initiator_wrapper.h"
@@ -119,14 +120,14 @@
       DspinSignals<dspin_int_cmd_width> signal_int_dspin_cmd_l2g_d;
       DspinSignals<dspin_int_cmd_width> signal_int_dspin_cmd_g2l_d;
+      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_l2g_d;
+      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_g2l_d;
       DspinSignals<dspin_int_cmd_width> signal_int_dspin_m2p_l2g_c;
       DspinSignals<dspin_int_cmd_width> signal_int_dspin_m2p_g2l_c;
       DspinSignals<dspin_int_cmd_width> signal_int_dspin_clack_l2g_c;
       DspinSignals<dspin_int_cmd_width> signal_int_dspin_clack_g2l_c;
-      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_l2g_d;
-      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_g2l_d;
       DspinSignals<dspin_int_rsp_width> signal_int_dspin_p2m_l2g_c;
       DspinSignals<dspin_int_rsp_width> signal_int_dspin_p2m_g2l_c;
 
-      // INT network VCI signals between VCI components and VCI/DSPIN wrappers
+      // INT network VCI signals between VCI components and VCI local crossbar
       VciSignals<vci_param_int> signal_int_vci_ini_proc[8];
       VciSignals<vci_param_int> signal_int_vci_ini_mdma;
@@ -140,25 +141,6 @@
       VciSignals<vci_param_int> signal_int_vci_tgt_iobx;
 
-      // INT network DSPIN signals between DSPIN local crossbars and VCI/DSPIN
-      // wrappers
-      DspinSignals<dspin_int_cmd_width> signal_int_dspin_cmd_proc_i[8];
-      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_proc_i[8];
-      DspinSignals<dspin_int_cmd_width> signal_int_dspin_cmd_mdma_i;
-      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_mdma_i;
-      DspinSignals<dspin_int_cmd_width> signal_int_dspin_cmd_iobx_i;
-      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_iobx_i;
-
-      DspinSignals<dspin_int_cmd_width> signal_int_dspin_cmd_memc_t;
-      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_memc_t;
-      DspinSignals<dspin_int_cmd_width> signal_int_dspin_cmd_xicu_t;
-      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_xicu_t;
-      DspinSignals<dspin_int_cmd_width> signal_int_dspin_cmd_brom_t;
-      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_brom_t;
-      DspinSignals<dspin_int_cmd_width> signal_int_dspin_cmd_mtty_t;
-      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_mtty_t;
-      DspinSignals<dspin_int_cmd_width> signal_int_dspin_cmd_mdma_t;
-      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_mdma_t;
-      DspinSignals<dspin_int_cmd_width> signal_int_dspin_cmd_iobx_t;
-      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_iobx_t;
+      VciSignals<vci_param_int> signal_int_vci_l2g;
+      VciSignals<vci_param_int> signal_int_vci_g2l;
 
       // Coherence DSPIN signals between DSPIN local crossbars and CC
@@ -205,25 +187,20 @@
 
       VciCcVCacheWrapperType*          proc[8];
-      VciIntDspinInitiatorWrapperType* proc_wi[8];
 
       VciMemCacheType*                 memc;
-      VciIntDspinTargetWrapperType*    memc_int_wt;
       VciExtDspinInitiatorWrapperType* memc_ram_wi;
 
       VciXicu<vci_param_int>*          xicu;
-      VciIntDspinTargetWrapperType*    xicu_int_wt;
 
       VciMultiDma<vci_param_int>*      mdma;
-      VciIntDspinInitiatorWrapperType* mdma_int_wi;
-      VciIntDspinTargetWrapperType*    mdma_int_wt;
 
       VciSimpleRom<vci_param_int>*     brom;
-      VciIntDspinTargetWrapperType*    brom_int_wt;
 
       VciMultiTty<vci_param_int>*      mtty;
-      VciIntDspinTargetWrapperType*    mtty_int_wt;
-
-      DspinLocalCrossbar<dspin_int_cmd_width>* int_xbar_cmd_d;
-      DspinLocalCrossbar<dspin_int_rsp_width>* int_xbar_rsp_d;
+
+      VciLocalCrossbar<vci_param_int>*  int_xbar_d;
+      VciIntDspinInitiatorWrapperType*  int_wi_gate_d;
+      VciIntDspinTargetWrapperType*     int_wt_gate_d;
+      
       DspinLocalCrossbar<dspin_int_cmd_width>* int_xbar_m2p_c;
       DspinLocalCrossbar<dspin_int_rsp_width>* int_xbar_p2m_c;
@@ -242,6 +219,4 @@
 
       VciIoBridge<vci_param_int, vci_param_ext>* iob;
-      VciIntDspinInitiatorWrapperType*           iob_int_wi;
-      VciIntDspinTargetWrapperType*              iob_int_wt;
       VciExtDspinInitiatorWrapperType*           iob_ram_wi;
 